-------------------------------------------------------------------------------
-- TradeSkillSearch
-------------------------------------------------------------------------------

TradeSkillSearch = {}
TradeSkillSearch.version = 3
TradeSkillSearch.x = 80
TradeSkillSearch.y = -49
TradeSkillSearch.w = 225
TradeSkillSearch.h = 25
TradeSkillSearch.rowHeight = 16

local function SearchTradeSkills()
	-- Search tradeskill list for first match.
	local s = TradeSkillSearchBox:GetText()
	for i=1,GetNumTradeSkills() do
		skillName, skillType, numAvailable, isExpanded, altVerb, numSkillUps, indentLevel, showProgressBar, currentRank, maxRank, startingRank = GetTradeSkillInfo(i)
		skillName = skillName:lower()
		if skillName:find(s) ~= nil then
			SelectTradeSkill(i)
			--TradeSkillListScrollFrame.offset = i - 1
			TradeSkillListScrollFrameScrollBar:SetValue((i-1) * TradeSkillSearch.rowHeight) 
			TradeSkillFrame_Update()
			return
		end
	end
end

local function SetupWidgets()
	-- Create label
	local f = CreateFrame("Frame", "TradeSkillSearchFrame", TradeSkillFrame)
	local text = f:CreateFontString(nil, "OVERLAY", "GameFontNormalSmall")
	text:SetPoint("LEFT")
	text:SetText("Search:")
	f:SetPoint("TOPLEFT", TradeSkillFrame, "TOPLEFT", TradeSkillSearch.x - 7, TradeSkillSearch.y)
	f:SetSize(TradeSkillSearch.w, TradeSkillSearch.h)
	-- Create search box
	local f = CreateFrame("EditBox", "TradeSkillSearchBox", TradeSkillFrame, "InputBoxTemplate")
	f:SetFrameLevel(4)
	f:SetPoint("CENTER")
	f:SetPoint("TOPLEFT", TradeSkillFrame, "TOPLEFT", TradeSkillSearch.x + text:GetWidth(), TradeSkillSearch.y)
	f:SetSize(TradeSkillSearch.w, TradeSkillSearch.h)
	f:SetAutoFocus(false)
	-- Search when editbox contents change
	f:HookScript("OnTextChanged", SearchTradeSkills)
	-- Or when tradeskill window first appears
	TradeSkillFrame:HookScript("OnShow", SearchTradeSkills)
	f:SetScript("OnEnterPressed", function(self)
		f:ClearFocus()
	end)
	f:SetScript("OnEscapePressed", function(self)
		f:SetText("")
		f:ClearFocus()
	end)
end

local setup = false

local frame = CreateFrame("Frame")
frame:RegisterEvent("ADDON_LOADED")
frame:SetScript("OnEvent", function(self, event, addOnName)
	--if addOnName == "Blizzard_TradeSkillUI" then
	if not setup and TradeSkillFrame ~= nil then
		setup = true
		SetupWidgets()
	end
end)
